import System --for benchmarking only

data Nat = Z | S Nat

--specialized for a given first argument (3):

main x = ack (S (S (S Z))) x

ack Z     n    = S n
ack (S m) Z    = ack m  (S Z)
ack (S m) (S n)= ack m  (ack (S m) n)

--for annotations:
GEN x = x

--only for benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main 
         (S (S (S (S (S (S (S (S Z))))))))))
        where x free

--run time average: 2186 ms
