import System --for benchmarking only

data Nat = Z | S Nat


main x = prod (fib x) (fib (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S Z)))))))))))))))) 

fib Z = S Z
fib (S Z) = S Z
fib (S (S x)) = sum (fib (S x)) (fib x)


prod Z y = Z
prod (S x) y = sum y (prod x y)

sum Z y = y
sum (S x) y = S (sum x y)

--for annotations:
GEN x = x

--only for benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S Z)))))))))))))))))
        where x free

--run time average: 2186 ms
