import System --for benchmarking

data Nat = Z | S Nat

-- specialized for 4:

main x = pow x (S (S (S (S Z))))

pow x Z     = S Z
pow x (S n) = mult x (pow x n)

mult Z     n  = Z
mult (S v) n  = sum n (mult v n)

sum Z     n = n
sum (S v) n = S (sum v n)

--for annotations
GEN x = x

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S Z))))))))))))))))))))))))
        where x free

