import System --for benchmarking

data Nat = Z | S Nat

--specialized for numbers greater than or equal to 5:
main x = PEVAL (gauss (S (S (S (S (S x))))))

gauss Z = Z
gauss (S n) = suma (S n) (gauss n)

suma Z     y = y
suma (S x) y = S (suma x y)

--for annotations:
GEN x = x

--benchmarking:

getExecTime act = do
  time1 <- getCPUTime
  act
  time2 <- getCPUTime
  return (time2-time1)

runBenchmark i b = do
  times <- sequenceIO $ take i (map (getExecTime . b) (repeat 1))
  putStrLn $ "Runtimes (msecs): "++show times
  putStrLn $ "Average (msecs): "++show ((foldr (+) 0 times) `div` length times)

bench = runBenchmark 10 (\_ -> print (x =:= main
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
         (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S 
          Z)))))))))))))))))))))))))))))))))))))))))))))))))))
         )))))))))))))))))))))))))))))))))))))))))))))))))))))
         )))))))))))))))))))))))))))))))))))))))))))))))))))))
         )))))))))))))))))))))))))))))))))))))))))))))))))))))
         )))))))))))))))))))))))))))))))))))))))))))))))))))))
         )))))))))))))))))))))))))))))))))))))))))))))))))))))
         )))))))))))))))))))))))))))))))))))))))))))))))))))))
         )))))))))))))))))))))))))))))))))))))))))))))))))))))
         ))))))))))))))))))))))))))))))))))))))))))))))))
        where x free

